View subclass:#FormDrawView
	 instanceVariableNames:'canvas'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Demos-Graphics'
!

FormDrawView comment:'
I implement a view which does drawing onto both the screen
and a backing canvas. From this canvas we redraw (there is also
a possibility to add printing etc)
'!

!FormDrawView methodsFor:'initialization'!

initialize
    super initialize.
    canvas := Form width:1024
		  height:768
		   depth:(Display depth).
    canvas paint:(Color white).
    canvas fillRectangleX:0 y:0 width:(canvas width) height:(canvas height)
! !

!FormDrawView methodsFor:'queries'!

widthOfContents
    ^ canvas width
!

heightOfContents
    ^ canvas height
! !

!FormDrawView methodsFor:'events'!

redrawX:x y:y width:w height:h
    "redraw from the canvas"

    |org|

    org := self viewOrigin.
    self function:#copy.
    self copyFrom:canvas 
		x:x
		y:y
	      toX:x-org x y:y-org y 
	    width:(w min:(canvas width - x))
	   height:(h min:(canvas height - y)).
! !

!FormDrawView methodsFor:'graphic access'!

paint:aColor
    canvas paint:aColor.
    super paint:aColor
!

capStyle:aStyle
    canvas capStyle:aStyle.
    super capStyle:aStyle
!

lineWidth:aNumber
    canvas lineWidth:aNumber.
    super lineWidth:aNumber
! !

!FormDrawView methodsFor:'drawing'!

clear
    canvas paint:(Color white).
    canvas fillRectangleX:0 y:0 width:(canvas width)
			       height:(canvas height).
    super clear
!

displayLineFromX:x1 y:y1 toX:x2 y:y2
    canvas displayLineFromX:x1 y:y1 toX:x2 y:y2.
    super displayLineFromX:x1 y:y1 toX:x2 y:y2
! !
