"
 'store into literal array bug' - demonstration
 ----------------------------------------------

 this file demonstrates a hard to find bug / strange feature.
 Storing into literal constants is allowed and leads to strange
 behavior. Read doc/online/../programming/classicBugs.html for
 a discussion of this (and how these bugs can be avoided in ST/X)

 FileIn this code and execute
	ArrayLiteralBugDemonstration new buggy1
	ArrayLiteralBugDemonstration new buggy2

 both with:
	Compiler arraysAreImmutable:true.

 and:
	Compiler arraysAreImmutable:false 


 You have to force recompilation after changing the immutable flag; i.e.:
	Compiler arraysAreImmutable:true.
	Smalltalk removeClass:ArrayLiteralBugDemonstration.
	Smalltalk fileIn:'../../doc/coding/Array-literalStore.st'

	Compiler arraysAreImmutable:false 
	Smalltalk removeClass:ArrayLiteralBugDemonstration.
	Smalltalk fileIn:'../../doc/coding/Array-literalStore.st'

"

Object subclass:#ArrayLiteralBugDemonstration
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Examples-Bugs'
!

!ArrayLiteralBugDemonstration methodsFor:'bug1'!

literalArray
    ^ #('hello' 'there')

    "
     ArrayLiteralBugDemonstration new literalArray 
    "
!

buggy1
    "
     thats obvious ...
    "
    Transcript show:'literalArray initially returns: ';
	       showCr:(self literalArray) displayString.

    (self literalArray) at:2 put:'wrong'.

    Transcript show:'literalArray now returns: ';
	       showCr:(self literalArray) displayString.

    Transcript showCr:'but the source is still:'.
    Transcript cr.
    Transcript nextPutAll:(self class compiledMethodAt:#literalArray) source.
    Transcript cr.

    "
     ArrayLiteralBugDemonstration new buggy1
    "
!

buggy2
    "
     less obvious ... hard to track down
    "
    Transcript show:'literalArray initially returns: ';
	       showCr:(self literalArray) displayString.

    Transcript show:'literalArray modified: ';
	       showCr:(self literalArray replaceAll:'hello' by:'bug') displayString.

    Transcript show:'literalArray now returns: ';
	       showCr:(self literalArray) displayString.

    Transcript showCr:'but the source is still:'.
    Transcript cr.
    Transcript nextPutAll:(self class compiledMethodAt:#literalArray) source.
    Transcript cr.

    "
     ArrayLiteralBugDemonstration new buggy2
    "
! !

