"
 'block unwinding' - demonstration
 ---------------------------------

 fileIn this file, then read the comments in example1 and example2
 and try it with:
	BlockUnwindExample example1
	BlockUnwindExample example2
"

Object subclass:#BlockUnwindExample
	 instanceVariableNames:''
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Examples-Blocks'
!

!BlockUnwindExample class methodsFor:'examples'!

example1
    "this method shows how the 'valueNowOrOnUnwindDo:' and
     'valueOnUnwindDo:' messages are used to make certain that
     cleanup actions are performed.

     'self doSomething' will be executed with a cleanup action defined (cleanup1).
     During the evaluation of doSomething, an error (halt) will happen.

     In the debugger select a context below (for example the 'example1'-context) 
     and return it (or simply abort).
     See that the cleanup action (just a print) will be executed.
     If you choose to continue in the debugger, no cleanup action is done."

    [
	self doSomething
    ] valueOnUnwindDo:[
	Transcript showCr:'cleanup action1 executed'
    ].

    Transcript showCr:'normal exit'

    "
     BlockUnwindExample example1
    "
!

exampleHelper
    "just a helper for example2"

    self example1
!

example2
    "another example - see how both cleanup1 and cleanup2 actions
     will be performed in case of an abort. Only cleanup action2 will
     be executed in case of a continue."

    [
	self exampleHelper
    ] valueNowOrOnUnwindDo:[
	Transcript showCr:'cleanup action2 executed'
    ].

    Transcript showCr:'normal exit'

    "
     BlockUnwindExample example2
    "
!

example3
    "this demonstrates, that cleanup actions are not only performed when
     returning via the signal mechanism, but also for normal long returns
     via blocks ..."

    [
	self goDown:5 then:[
	    Transcript showCr:'now returning'.
	    ^ self
	]
    ] valueNowOrOnUnwindDo:[
	Transcript showCr:'cleanup action executed'
    ].

    Transcript showCr:'normal exit'

    "
     BlockUnwindExample example3
    "
!

doSomething
    "just a dummy action"

    self goDown:5 then:[
	Transcript showCr:'now halting'.
	self halt:'press abort or continue, please'.
	Transcript showCr:'after halt'
    ]
!

goDown:n then:aBlock
    Transcript showCr:'down ..'.

    n > 0 ifTrue:[
	^ self goDown:n - 1 then:aBlock
    ].
    aBlock value.
! !
