"
 'misc ways of subclassing' - demonstration
 ------------------------------------------

 these code fragments create various types of subclasses.
 FileIn this and watch the Transcript.

 They also show, that in ST/X you CAN have variableByte
 classes WITH named instance variables (i.e. subclassing String,
 Symbol etc. is allowed). 
 However, keep in mind that this is a non-portable feature, since other 
 Smalltalk implementations may not support this.

 The same warning applies to variableWord, variableFloat
 and variableDouble classes. Especially the last two were
 added to provide some (higher performance) support for
 3D graphics and vector processors.
"

"************************************************************************"

Transcript showCr:'definining a variableByte class ...'!

Object variableByteSubclass:#SubclassingExample1
	 instanceVariableNames:'inst1 inst2'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Examples-Subclassing'!

!SubclassingExample1 methodsFor:'accessing'!

inst1:anObject
    inst1 := anObject
!

inst2:anObject
    inst2 := anObject
! !

|o|

Transcript showCr:'creating an instance ...'.
o := SubclassingExample1 new:5.
o inst1:#inst1.
o inst2:#inst2.
o at:1 put:5.
o at:2 put:4.
o at:3 put:3.
o at:4 put:2.
o at:5 put:1.
Transcript showCr:o printString; cr
!

"************************************************************************"

Transcript showCr:'definining a subclass of a variableByte class ...'!

SubclassingExample1 subclass:#SubclassingExample1b
	 instanceVariableNames:'inst3'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Examples-Subclassing'!

!SubclassingExample1b methodsFor:'accessing'!

inst3:anObject
    inst3 := anObject
! !

|o|

Transcript showCr:'creating an instance ...'.
o := SubclassingExample1b new:5.
o inst1:#inst1.
o inst2:#inst2.
o inst3:#inst3.
o at:1 put:5.
o at:2 put:4.
o at:3 put:3.
o at:4 put:2.
o at:5 put:1.
Transcript showCr:o printString; cr
!

"************************************************************************"

Transcript showCr:'definining a subclass of string ...'!

String subclass:#SubclassingExample1c
	 instanceVariableNames:'inst1'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Examples-Subclassing'!

!SubclassingExample1c class methodsFor:'accessing'!

new
    ^ (super new) initialize
!

new:size
    ^ (super new:size) initialize
! !

!SubclassingExample1c methodsFor:'accessing'!

instvar
    ^ inst1
!

instvar:something
    inst1 := something
! !

!SubclassingExample1c methodsFor:'setup'!

initialize
    inst1 := #additionalInstvarsValue
! !

!SubclassingExample1c methodsFor:'copying'!

copyEmpty
    ^ (super copyEmpty) instvar:inst1
! !


|o|

Transcript showCr:'creating an instance ...'.
o := SubclassingExample1c withAll:'hello world'.
Transcript show:'prints as: '; showCr:o printString.
Transcript show:'but has instance: '; showCr:o instvar printString.
Transcript show:'copy has instance: '; showCr:o copy instvar printString.
Transcript show:'compares with string: '; showCr:(o = 'hello world') printString; cr.
!

"************************************************************************"

Transcript showCr:'definining a variableWord class ...'!

Object variableWordSubclass:#SubclassingExample2
	 instanceVariableNames:'inst1 inst2'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Examples-Subclassing'!

!SubclassingExample2 methodsFor:'accessing'!

inst1:anObject
    inst1 := anObject
!

inst2:anObject
    inst2 := anObject
! !

|o|

Transcript showCr:'creating an instance ...'.
o := SubclassingExample2 new:5.
o inst1:#inst1.
o inst2:#inst2.
o at:1 put:16rFFFF.
o at:2 put:3.
o at:3 put:2.
o at:4 put:1.
o at:5 put:0.
Transcript showCr:o printString; cr
!

"************************************************************************"

Transcript showCr:'definining a subclass of a variableWord class ...'!

SubclassingExample2 subclass:#SubclassingExample2b
	 instanceVariableNames:'inst3'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Examples-Subclassing'!

!SubclassingExample2b methodsFor:'accessing'!

inst3:anObject
    inst3 := anObject
! !

|o|

Transcript showCr:'creating an instance ...'.
o := SubclassingExample2b new:5.
o inst1:#inst1.
o inst2:#inst2.
o inst3:#inst3.
o at:1 put:16rFFFF.
o at:2 put:3.
o at:3 put:2.
o at:4 put:1.
o at:5 put:0.
Transcript showCr:o printString; cr
!

"************************************************************************"

Transcript showCr:'definining a variableLong class ...'!

Object variableLongSubclass:#SubclassingExample3
	 instanceVariableNames:'inst1 inst2'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Examples-Subclassing'!

!SubclassingExample3 methodsFor:'accessing'!

inst1:anObject
    inst1 := anObject
!

inst2:anObject
    inst2 := anObject
! !

|o|

Transcript showCr:'creating an instance ...'.
o := SubclassingExample3 new:5.
o inst1:#inst1.
o inst2:#inst2.
"o at:1 put:16rFFFFFFFF."     "this must work, retrieve a long on access"
o at:2 put:3.
o at:3 put:2.
o at:4 put:1.
o at:5 put:0.
Transcript showCr:o printString; cr
!

"************************************************************************"

Transcript showCr:'definining a subclass of a variableLong class ...'!

SubclassingExample3 subclass:#SubclassingExample3b
	 instanceVariableNames:'inst3'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Examples-Subclassing'!

!SubclassingExample3b methodsFor:'accessing'!

inst3:anObject
    inst3 := anObject
! !

|o|

Transcript showCr:'creating an instance ...'.
o := SubclassingExample3b new:5.
o inst1:#inst1.
o inst2:#inst2.
o inst3:#inst3.
"o at:1 put:16rFFFFFFFF."
o at:2 put:3.
o at:3 put:2.
o at:4 put:1.
o at:5 put:0.
Transcript showCr:o printString; cr
!

"************************************************************************"

Transcript showCr:'definining a variableFloat class ...'!

Object variableFloatSubclass:#SubclassingExample4
	 instanceVariableNames:'inst1 inst2'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Examples-Subclassing'!

!SubclassingExample4 methodsFor:'accessing'!

inst1:anObject
    inst1 := anObject
!

inst2:anObject
    inst2 := anObject
! !

|o|

Transcript showCr:'creating an instance ...'.
o := SubclassingExample4 new:5.
o inst1:#inst1.
o inst2:#inst2.
o at:1 put:0.0.     
o at:2 put:1.0.
o at:3 put:2.0.
o at:4 put:3.0.
o at:5 put:4.0.
Transcript showCr:o printString; cr
!

"************************************************************************"

Transcript showCr:'definining a subclass of a variableFloat class ...'!

SubclassingExample4 subclass:#SubclassingExample4b
	 instanceVariableNames:'inst3'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Examples-Subclassing'!

!SubclassingExample4b methodsFor:'accessing'!

inst3:anObject
    inst3 := anObject
! !

|o|

Transcript showCr:'creating an instance ...'.
o := SubclassingExample4b new:5.
o inst1:#inst1.
o inst2:#inst2.
o inst3:#inst3.
o at:1 put:0.0.     
o at:2 put:1.0.
o at:3 put:2.0.
o at:4 put:3.0.
o at:5 put:4.0.
Transcript showCr:o printString; cr
!

"************************************************************************"

Transcript showCr:'definining a variableDouble class ...'!

Object variableDoubleSubclass:#SubclassingExample5
	 instanceVariableNames:'inst1 inst2'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Examples-Subclassing'!

!SubclassingExample5 methodsFor:'accessing'!

inst1:anObject
    inst1 := anObject
!

inst2:anObject
    inst2 := anObject
! !

|o|

Transcript showCr:'creating an instance ...'.
o := SubclassingExample5 new:5.
o inst1:#inst1.
o inst2:#inst2.
o at:1 put:0.0.     
o at:2 put:1.0.
o at:3 put:2.0.
o at:4 put:3.0.
o at:5 put:4.0.
Transcript showCr:o printString; cr
!

"************************************************************************"

Transcript showCr:'definining a subclass of a variableDouble class ...'!

SubclassingExample5 subclass:#SubclassingExample5b
	 instanceVariableNames:'inst3'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Examples-Subclassing'!

!SubclassingExample5b methodsFor:'accessing'!

inst3:anObject
    inst3 := anObject
! !

|o|

Transcript showCr:'creating an instance ...'.
o := SubclassingExample5b new:5.
o inst1:#inst1.
o inst2:#inst2.
o inst3:#inst3.
o at:1 put:0.0.     
o at:2 put:1.0.
o at:3 put:2.0.
o at:4 put:3.0.
o at:5 put:4.0.
Transcript showCr:o printString; cr
!

"************************************************************************"
