 'fileIO' - examples
 -------------------

 short coding fragments on file I/O


  Textfiles:

    writing (create the file, or truncate if existing):

	|myStream|

	myStream := 'testfile' asFilename writeStream.
	myStream nextPutAll:'hello world'.
	myStream cr.
	myStream close

	alternative:

	|myStream|

	myStream := FileStream newFileNamed:'testfile'.
	myStream nextPutAll:'hello world'.
	myStream cr.
	myStream close

    appending:

	|myStream|

	myStream := FileStream appendingOldFileNamed:'testfile'.
	myStream nextPutAll:'hello world'.
	myStream cr.
	myStream close

    rewriting:

	|myStream|

	myStream := FileStream oldFileNamed:'testfile'.
	myStream nextPutAll:'***** *****'.
	myStream close


  Binaryfiles:

    writing (create the file, or truncate if existing):

	|myStream buffer|

	myStream := 'testfile2' asFilename writeStream.
	myStream binary.
	myStream nextPut:1;     "writing bytes"
		 nextPut:2;
		 nextPut:3;
		 nextPut:4.
	myStream nextPutShort:16r1234 MSB:true.
	myStream nextPutShort:16r1234 MSB:true.
	myStream nextPutShort:16r1234 MSB:false.
	myStream nextPutShort:16r1234 MSB:false.
	myStream nextPutShort:16r8765 MSB:true.
	myStream nextPutShort:16r8765 MSB:true.
	myStream nextPutShort:16r8765 MSB:false.
	myStream nextPutShort:16r8765 MSB:false.

	myStream nextPutLong:16r12345678 MSB:true.
	myStream nextPutLong:16r12345678 MSB:true.
	myStream nextPutLong:16r12345678 MSB:false.
	myStream nextPutLong:16r12345678 MSB:false.
	myStream nextPutLong:16r87654321 MSB:true.
	myStream nextPutLong:16r87654321 MSB:true.
	myStream nextPutLong:16r87654321 MSB:false.
	myStream nextPutLong:16r87654321 MSB:false.

	myStream nextPutLong:16r12345678 MSB:true.
	myStream nextPutLong:16r12345678 MSB:true.
	myStream nextPutLong:16r12345678 MSB:false.
	myStream nextPutLong:16r12345678 MSB:false.
	myStream nextPutLong:16r87654321 MSB:true.
	myStream nextPutLong:16r87654321 MSB:true.
	myStream nextPutLong:16r87654321 MSB:false.
	myStream nextPutLong:16r87654321 MSB:false.

	myStream nextPutAll:#[10 9 8 7 6 5 4 3 2 1].    "a byte array"
	buffer := 'abcdefghijklmnopqrstuvwxyz'.
	myStream nextPutBytes:16 from:buffer startingAt:3.
	myStream close

    reading:

	|myStream buffer|

	Integer displayRadix:16.   "looks better here ..."
	myStream := 'testfile2' asFilename readStream.
	myStream binary.

	Transcript cr; showCr:'bytes ...'.
	Transcript showCr:(myStream next:4).

	Transcript cr; showCr:'shorts ...'.
	Transcript show:(myStream nextShortMSB:true) displayString; space.
	Transcript show:(myStream nextShortMSB:false) displayString; space.
	Transcript show:(myStream nextShortMSB:true) displayString; space.
	Transcript show:(myStream nextShortMSB:false) displayString; space.
	Transcript show:(myStream nextShortMSB:true) displayString; space.
	Transcript show:(myStream nextShortMSB:false) displayString; space.
	Transcript show:(myStream nextShortMSB:true) displayString; space.
	Transcript show:(myStream nextShortMSB:false) displayString; space.
	Transcript cr.

	Transcript cr; showCr:'longs ...'.
	Transcript show:(myStream nextLongMSB:true) displayString; space.
	Transcript show:(myStream nextLongMSB:false) displayString; space.
	Transcript show:(myStream nextLongMSB:true) displayString; space.
	Transcript show:(myStream nextLongMSB:false) displayString; space.
	Transcript show:(myStream nextLongMSB:true) displayString; space.
	Transcript show:(myStream nextLongMSB:false) displayString; space.
	Transcript show:(myStream nextLongMSB:true) displayString; space.
	Transcript show:(myStream nextLongMSB:false) displayString; space.
	Transcript cr.

	Transcript cr; showCr:'unsigned longs ...'.
	Transcript show:(myStream nextUnsignedLongMSB:true) displayString; space.
	Transcript show:(myStream nextUnsignedLongMSB:false) displayString; space.
	Transcript show:(myStream nextUnsignedLongMSB:true) displayString; space.
	Transcript show:(myStream nextUnsignedLongMSB:false) displayString; space.
	Transcript show:(myStream nextUnsignedLongMSB:true) displayString; space.
	Transcript show:(myStream nextUnsignedLongMSB:false) displayString; space.
	Transcript show:(myStream nextUnsignedLongMSB:true) displayString; space.
	Transcript show:(myStream nextUnsignedLongMSB:false) displayString; space.
	Transcript cr.

	Transcript cr; showCr:'bytes ...'.
	Transcript showCr:(myStream next:10).

	Transcript cr; showCr:'more bytes ...'.
	buffer := String new:16.
	Transcript show:(myStream nextBytes:16 into:buffer); space; showCr:buffer.
	myStream close.
	Integer displayRadix:10.
