Object subclass:#RegistryExample
         instanceVariableNames:'myName'
         classVariableNames:'Lobby'
         poolDictionaries:''
         category:'Examples-Registry'
!

!RegistryExample class methodsFor:'examples'!

example1
    "this creates objects, which, when destroyed print a message on the Transcript.
     (actually a phantom is doing this, but who cares)"

    |o1 o2 o3 o4 o5|

    Transcript cr.
    Transcript showCr:'creating 5 objects (o1 .. o5)'.

    o1 := (self new name:'object1').
    o2 := (self new name:'object2').
    o3 := (self new name:'object3').
    o4 := (self new name:'object4').
    o5 := (self new name:'object5').

    Transcript showCr:'creating a registry ...'.

    Lobby isNil ifTrue:[
        Lobby := Registry new.
    ].

    Transcript showCr:'register o1 ...'.
    Lobby register:o1.
    Transcript showCr:'register o2 ...'.
    Lobby register:o2.
    Transcript showCr:'register o3 ...'.
    Lobby register:o3.
    Transcript showCr:'register o4 ...'.
    Lobby register:o4.
    Transcript showCr:'register o5 ...'.
    Lobby register:o5.

    "they are still living ..."

    Transcript showCr:'doing a GC, but all are still referenced; so nothing happens now ...'.
    ObjectMemory scavenge.

    "now, one of them should scream ..."

    Transcript showCr:'releasing ref to o3'.
    o3 := nil.
    Transcript showCr:'doing a GC; now o3 should scream ...'.
    ObjectMemory scavenge.

    "now, another one should scream ..."

    Transcript showCr:'releasing ref to o1'.
    o1 := nil.
    Transcript showCr:'doing a GC; now o1 should scream ...'.
    ObjectMemory scavenge.

    "the rest will shout sometime after this ..."

    Transcript showCr:'the others (o2, o4 and o5) will follow soon (when next garbage collect occures).'.

    "RegistryExample example1"
! !

!RegistryExample methodsFor:'setup'!

name:aString
    myName := aString
! !

!RegistryExample methodsFor:'printing'!

printString
    ^ self class name , '-' , myName 
! !

!RegistryExample methodsFor:'instance destruction'!

disposed
    Transcript showCr:'here is ' , myName , '. I was destroyed !!'
! !
