"
 this example shows, that Symbol can be subclassed, even
 adding an instvar (which allows to attach some value, such
 as external coding, enum-type value etc. to be easily associated
 with symbols.

 The VM treats subclasses of Symbol just as any other symbol,
 concerning method lookup. However, since comparison is done
 using identity check, a Symbol named #foo is not equivalent
 to an instance of a subclass of Symbol with the same name.
"

Symbol subclass:#EnumSymbol
	 instanceVariableNames:'value'
	 classVariableNames:''
	 poolDictionaries:''
	 category:Examples-EnumSymbol'
!

!EnumSymbol methodsFor:'accessing'!

value
    "return value"

    ^ value
!

value:something
    "set value"

    value := something.
! !

!EnumSymbol methodsFor:'printing'!

displayString
    ^ self printString
!

printOn:aStream
    aStream nextPutAll:self.
    aStream nextPutAll:'(value = '.
    value printOn:aStream.
    aStream nextPutAll:')'.
! !

"/ (EnumSymbol fromString:'fooBar') value:1.
"/ #fooBar printOn:Transcript
!







