StandardSystemView subclass:#TwoByteStringDemo3
       instanceVariableNames:'b1 b2 b3'
       classVariableNames:''
       poolDictionaries:''
       category:'Examples-16bitStrings'
!

TwoByteStringDemo3 comment:'
 demonstrates use of 16-bit strings in buttons

 start with:
     TwoByteStringDemo3 start

 (takes a while to come up the first time, since the Xserver
  must load the huge k14 font ...)

 If there is no k14 font on your machine, replace k14
 by some other 16bit font (12x24kana, kana14, fangsong ...)

 %W% %E%
 written mar 94 by claus
'!

!TwoByteStringDemo3 class methodsFor:'startup'!

start
    |aDemo|


    aDemo := self
		label:'16bit string buttons'
		icon:(Form fromFile:'Demo.xbm' resolution:100)
		minExtent:(50 @ 50)
		maxExtent:(1000 @ 1000).
    aDemo extent:(300 @ 100).
    aDemo open.
    ^ aDemo

    "
     TwoByteStringDemo3 start
    "
! !

!TwoByteStringDemo3 methodsFor:'defaults'!

fontToUse
    ^ 'k14'
! !

!TwoByteStringDemo3 methodsFor:'initialization'!

initialize
    |s f p nm|

    super initialize.

    nm := self fontToUse.
    (device fontFamilies includes:nm) ifFalse:[
	self warn:'no ' , nm , ' font available - required for this demo'.
    ].
    f := Font family:nm face:nil style:nil size:nil.

    p := HorizontalPanelView origin:(0.0 @ 0.0) corner:(1.0 @ 1.0) in:self.

    b1 := Button in:p.
    b1 label:(TwoByteString with:(Character value:16r2541)).
    b1 font:f.

    b2 := Button in:p.
    b2 label:(TwoByteString with:(Character value:16r3144)).
    b2 font:f.

    b3 := Button in:p.
    b3 label:(TwoByteString with:(Character value:16r5055)).
    b3 font:f.
! !
