StandardSystemView subclass:#ShapeView2
       instanceVariableNames:''
       classVariableNames:''
       poolDictionaries:''
       category:'Examples-Views-Tutorial'
!

ShapeView2 comment:'
 demonstrates how arbitrary patterns can be used as shape
 in this example, a bitmaps 1-bits are taken as view shape,
 effectively creating a somewhat transparent view.

 This works only, if your X-server supports the XShape
 extension - which is usually the case.

 However, the motif window manager does NOT support it
 (I dont know about the newest version though ..)

 Be prepared, that most X-servers have performance problems
 handling this kind of view-shape ...
 If you have a very good X-server, try move-opaque :-)

 start with:

 ShapeView2 new open

 %W% %E%
 written mar 94 by claus
'!

!ShapeView2 class methodsFor:'defaults'!

defaultExtent
    ^ 200 @ 200
! !

!ShapeView2 methodsFor:'initialization'!

initialize
    super initialize.
    self label:'a funny shape'.
    self viewBackground:Color black.
    self computeShape

    "ShapeView2 new open"
! !

!ShapeView2 methodsFor:'handling size changes'!

sizeChanged:how
    "must compute a new shape, when size is changed"

    self computeShape.
    super sizeChanged:how
! !

!ShapeView2 methodsFor:'shape computation'!

computeShape
    "define a funny shape"

    |img magnifiedImage form|


"/    img := (Image fromFile:'bitmaps/claus.gif').

"/     img := (Image fromFile:'bitmaps/garfield.gif').

    img := (Image fromFile:'bitmaps/globe1.xbm').

    img isNil ifTrue:[
	self warn:'shape bitmap not existing/not readable'.
	^ self
    ].
    magnifiedImage := img magnifyBy:(width / img width) @ (height / img height).
    form := magnifiedImage asMonochromeFormOn:Display.
    self borderShape:form.
    self viewShape:form
! !
