StandardSystemView subclass:#FillArcDemo1
       instanceVariableNames:'colors'
       classVariableNames:''
       poolDictionaries:''
       category:'Examples-Views-Tutorial'
!

FillArcDemo1 comment:'
 how to fill arcs 

 start with:

    FillArcDemo1 start:20 

 (replace 20 by whatever number of segments you like)

 %W% %E%
 written july 93 by claus
'!

!FillArcDemo1 class methodsFor:'startup'!

start:n
    |aDemo|


    aDemo := self
		label:'FillArcDemo1'
		icon:(Form fromFile:'Demo.xbm' resolution:100)
		minExtent:(50 @ 50)
		maxExtent:(1000 @ 1000).
    aDemo nColors:n.
    aDemo extent:(100 @ 100).
    aDemo open.
    ^ aDemo

    "
     FillArcDemo1 start:12
    "
! !

!FillArcDemo1 methodsFor:'initialization'!

nColors:numColors 
    |grey|

    super initialize.

    colors := Array new:numColors.
    0 to:numColors-1 do:[:segment |
	grey := 100 / (numColors - 1) * segment.
	colors at:(segment + 1) put:(Color grey:grey)
    ]
! !

!FillArcDemo1 methodsFor:'redrawing'!

redraw
    |nSegment angle startAngle|

    self clear.
    nSegment := colors size.
    angle := 360.0 / nSegment.
    startAngle := 0.0 .
    1 to:nSegment do:[:segment |
	self paint:(colors at:segment).
	self fillArcX:0 y:0
		    w:width-1 h:height-1
		 from:startAngle angle:angle.
	startAngle := startAngle + angle.
    ]
! !
